function createUser(e){
    e.preventDefault()
    const username = document.getElementById('create-username').value
    const password = document.getElementById('create-password').value

    const user = {
        username,
        password: md5(password)
    }
    fetch('/sign-up', {
            'method': 'POST',
            'headers': {
                'Content-Type': 'application/json',
                'Accept': 'application/json'
            },
            'body': JSON.stringify(user)
        })
        .then(async resp => {
            let el = document.getElementById('create-message')
            // add/remove error styling based on response status
            if(resp.status !== 200) el.classList.add('err')
            else el.classList.remove('err')
            // add message
            let data = await resp.json()
            el.innerHTML = data.message
        })
}

function login(e){
    e.preventDefault()
    const username = document.getElementById('login-username').value
    const password = document.getElementById('login-password').value

    // Note: We are not using SSL so it would be unwise to pass passwords
    // as plain text. Also, hashing stops a compromised server from
    // leaking unhashed passwords. In real life, however, SSL/HTTPS is the
    // way to go, and hashing on the client side is rarely seen.
    const user = {
        username,
        password: md5(password)
    }
    fetch('/sign-in', {
            'method': 'POST',
            'headers': {
                'Content-Type': 'application/json',
                'Accept': 'application/json'
            },
            'body': JSON.stringify(user)
        })
        .then(async resp => {
            let el = document.getElementById('login-message')
            // add/remove error styling based on response status
            if(resp.status !== 200) el.classList.add('err')
            else el.classList.remove('err')
            // add message
            let data = await resp.json()
            el.innerHTML = data.message
        })
}

function logout(e){
    e.preventDefault()
    fetch('/logout', { 'method': 'POST' })
}

function checkStatus(){
    fetch('/status', {
            'method': 'POST',
            'headers': {
                'Accept': 'application/json'
            }
        })
        .then(async resp => {
            let data = await resp.json()
            let el = document.getElementById('status')
            el.innerHTML = data.message
        })
}

window.onload = () => {
    document.getElementById('register').addEventListener('click', createUser)
    document.getElementById('login').addEventListener('click', login)
    document.getElementById('logout').addEventListener('click', logout)

    // Check login status with a given interval, for demonstration purposes only.
    setInterval(checkStatus, 500)
}