// app.js
const express = require('express')
const sessions = require('express-session')
const cookieParser = require('cookie-parser')

const app = express();
const userRoutes = require('./routes/userRoutes.js')

const port = 3000;
 
app.use(express.json())
app.use(express.static('public'))

// create a session
app.use(sessions({
	secret: 'secr3t', // a random unique string key used to authenticate a session
	saveUninitialized: true,
    resave: false,
    cookie: { maxAge: 1000 * 60 * 60 * 24 } // expire after one day
}));
app.use(cookieParser());
 

// make sure to add the routes last for middleware to apply
app.use(userRoutes)

app.listen(port, ()=> {
    console.log(`App is listening on port ${port}`);        
})